# -*- coding: utf-8 -*-

import codecs, math, os
from collections import defaultdict


def DosyaOku():
    script_dir = os.path.dirname(__file__)
    rel_path = '../res/ydc_formal.txt'
    abs_file_path = os.path.join(script_dir, rel_path)
    filehandle = open(abs_file_path)

    veri = filehandle.read()

    filehandle.close()
    return veri


def KomsuKavsakGetir():
    veriler = []
    KomsuKavsaklar = [[]]

    veri = DosyaOku()
    for i in veri.split("\n"):
        veriler.append(i)
    for i in veriler:
        if i != "NOKTALAR:" and i != "" and i != "KOMŞULUKLAR:":
            i = i.replace("wp", "").replace("-", " ")
            raw, row = i.split()
            KomsuKavsaklar.append([int(raw), int(row)])
        elif i == "NOKTALAR:":
            break
    KomsuKavsaklar.pop(0)
    print("KomsuKavsaklar: ", KomsuKavsaklar)
    return KomsuKavsaklar


def KavsakNoktaGetir():
    nokta_kontrol = False
    veriler = []

    KavsakKoordinat = [[]]
    veri = DosyaOku()
    for i in veri.split("\n"):
        veriler.append(i)
    silinecek = "abcçdefgğhıijklmnoöprsştuüvyz"
    for j in veriler:
        if j == "NOKTALAR:":
            nokta_kontrol = True
        if (nokta_kontrol and j != "" and j != "NOKTALAR:"):
            degisim = j
            degisim = degisim.replace("wp", "").replace("(", " ").replace(")", " ").replace(",", " ").replace("[C]", "")
            for char in silinecek:
                degisim = degisim.replace(char, "")
            a, x, y, z = degisim.split()
            KavsakKoordinat.append([int(a), float(x), float(y), float(z)])
    KavsakKoordinat.pop(0)
    print("KavsakKoordinat: ", KavsakKoordinat)
    return KavsakKoordinat


def build_graph(edge_list):
    graph = defaultdict(list)
    seen_edges = defaultdict(int)
    for src, dst, weight in edge_list:
        seen_edges[(src, dst, weight)] += 1
        if seen_edges[(src, dst, weight)] > 1:  # checking for duplicated edge entries
            continue
        graph[src].append((dst, weight))
        graph[dst].append((src, weight))  # remove this line of edge list is directed
    return graph

def dijkstra(graph, src, dst=None):
    nodes = []
    for n in graph:
        nodes.append(n)
        nodes += [x[0] for x in graph[n]]

    q = set(nodes)
    nodes = list(q)
    dist = dict()
    prev = dict()
    for n in nodes:
        dist[n] = float('inf')
        prev[n] = None

    dist[src] = 0

    while q:
        u = min(q, key=dist.get)
        q.remove(u)

        if dst is not None and u == dst:
            return dist[dst], prev

        for v, w in graph.get(u, ()):
            alt = dist[u] + w
            if alt < dist[v]:
                dist[v] = alt
                prev[v] = u

    return dist, prev

def find_path(pr, node):  # generate path list based on parent points 'prev'
    p = []
    while node is not None:
        p.append(node)
        node = pr[node]
    return p[::-1]

def Uzaklik(p0, p1): return (p0 - p1)

def dist(coord1, coord2):
    distance = math.sqrt(((coord1[0] - coord2[0]) ** 2) + ((coord1[1] - coord2[1]) ** 2))
    return distance

def NoktalariOlustur(ikaKoord, hedefKoord, KavsakKoordinat, KomsuKavsaklar):
    hedef_konum = hedefKoord
    ika_koordinat = ikaKoord
    tum_koordinatlar = [ika_koordinat] + KavsakKoordinat + [hedef_konum]
    tum_koordinatlar_birbirlerine_uzaklik = [[]]
    GidilecekKoordinatlar = [[]]

    flag = 1
    for i in range(0, len(KavsakKoordinat)):
        index = KavsakKoordinat[i][0]
        x = KavsakKoordinat[i][1]
        y = KavsakKoordinat[i][2]
        if(flag == 1):
            koordArasiUzaklik = dist(hedef_konum, [x, y])
            min_index = index
            min = koordArasiUzaklik
            flag = 0

        else:
            koordArasiUzaklik = dist(hedef_konum, [x, y])
            if koordArasiUzaklik < min:
                min = koordArasiUzaklik
                min_index = index
    hedefIndex = min_index

    flag = 1
    for i in range(0, len(KavsakKoordinat)):
        index = KavsakKoordinat[i][0]
        x = KavsakKoordinat[i][1]
        y = KavsakKoordinat[i][2]
        if (flag == 1):
            koordArasiUzaklik = dist(ika_koordinat, [x, y])
            min_index = index
            min = koordArasiUzaklik
            flag = 0

        else:
            koordArasiUzaklik = dist(ika_koordinat, [x, y])
            if koordArasiUzaklik < min:
                min = koordArasiUzaklik
                min_index = index
    ikaIndex = min_index


    for k in range(0,len(KomsuKavsaklar)):

        kavsak1 = KomsuKavsaklar[k][0]
        kavsak2 = KomsuKavsaklar[k][1]
        koordinat1 = [tum_koordinatlar[kavsak1][1], tum_koordinatlar[kavsak1][2]]
        koordinat2 = [tum_koordinatlar[kavsak2][1], tum_koordinatlar[kavsak2][2]]
        uzaklik = dist(koordinat1, koordinat2)
        tum_koordinatlar_birbirlerine_uzaklik.append((kavsak1, kavsak2, uzaklik))

    tum_koordinatlar_birbirlerine_uzaklik.pop(0)

    g = build_graph(tum_koordinatlar_birbirlerine_uzaklik)
    d, prev = dijkstra(g, ikaIndex, hedefIndex)
    path = find_path(prev, hedefIndex)
    for i in path:
        x = KavsakKoordinat[i-1][1]
        y = KavsakKoordinat[i-1][2]
        GidilecekKoordinatlar.append([x,y])
    GidilecekKoordinatlar.pop(0)
    GidilecekKoordinatlar.append(hedef_konum)

    # print("Sirayla Gidilecek Koordinatlar:", GidilecekKoordinatlar, "Uzaklik:", d)
    return GidilecekKoordinatlar, d


def constrain(input, low, high):
    if input < low:
        input = low
    elif input > high:
        input = high
    else:
        input = input
    return input


def uav_checkLimitSpeed(vel, max):
    vel = constrain(vel, -max, max)
    return vel

def ugv_checkLimitThrottle(vel, max):
    vel = constrain(vel, -max, max)
    return vel

def ugv_checkLimitSteering(vel, max):
    vel = constrain(vel, -max, max)
    return vel

# O anki x,y,z hizlari
def uav_vels(target_lin_z_speed, target_lin_x_speed, target_lin_y_speed, target_ang_z_speed):
    return 'currently:\t linear_z %s\t linear_x %s\t linear_y %s\t angular_z %s ' % (
        target_lin_z_speed, target_lin_x_speed, target_lin_y_speed, target_ang_z_speed)


def ugv_vels(target_throttle, target_steering, target_break, target_handbreak):
    return "currently:\t throttle %s\t steering %s\t break %s\t handbreak %s " % (
        target_throttle, target_steering, target_break, target_handbreak)

def firstStatus(uav_koord, gidilecek_coord):
    global hiz_x
    global hiz_y
    global hiz_z
    global fDistance
    global x_loc
    global y_loc
    global z_loc
    global hiz_x
    global hiz_y
    global hiz_z

    x_uzak = gidilecek_coord[0] - uav_koord[0]
    y_uzak = gidilecek_coord[1] - uav_koord[1]
    z_uzak = gidilecek_coord[2] - uav_koord[2]

    toplam_uzak = pow(x_uzak,2) + pow(y_uzak,2) + pow(z_uzak,2)

    fDistance = math.sqrt(toplam_uzak)

    hiz_x = Uzaklik(gidilecek_coord[0] - uav_koord[0]) * 0.2
    hiz_y = Uzaklik(gidilecek_coord[1] - uav_koord[1]) * 0.2
    hiz_z = Uzaklik(gidilecek_coord[2] - uav_koord[2])

    if (hiz_z > 0.0):
        hiz_z = 2
    else:
        hiz_z = hiz_z * 0.2

    # print("Ort x hiz", hiz_x)
    # print("Ort y hiz", hiz_y)
    # print("Ort z hiz", hiz_z)
    # print("Toplam uzaklik: ", fDistance)

def desarj(name,dictionary, hizx,hizy,hizz):
    global func
    global cargoWeight

    cargoWeight = dictionary[name].get("cargo_weight")  # z
    cargoWeight = float(cargoWeight)

    hizpow = pow(hizx, 2) + pow(hizy, 2) + pow(hizz, 2)
    vel = math.sqrt(hizpow)  # x
    a = pow(2 * vel, 0.75)
    c = (cargoWeight + 1) / 15
    b = pow(c, 0.16666666666666666)
    func = (1 + a * b) * 100
    return func

def SarjHaber(name,dictionary):
       if (dictionary[name].get("fuel_current") == dictionary[name].get("fuel_capacity")):
        return True
       else:
        return False


def chargeStation(name,dictionary, MaxHiz, charge_station_uzaklik):
    global fDistance
    global x_loc
    global y_loc
    global z_loc
    global hiz_x
    global hiz_y
    global hiz_z
    global minindex

    # uzaklik = (dictionary[name]["uav_x"] - other_x)**2 + (dictionary[name]["uav_y"] - other_y)**2 + (dictionary[name]["uav_z"] - other_z)**2
    func = desarj(name, dictionary,MaxHiz/2, MaxHiz/2, MaxHiz/2)
    print("desarj:", func)
    fcurrent = dictionary[name].get("fuel_current")


    # minstation = math.sqrt((dictionary[name]["uav_x"] - charge_station[0][0])**2 + (dictionary[name]["uav_y"] - charge_station[0][1])**2 + (dictionary[name]["uav_z"] - charge_station[0][2])**2)
    sarj = func * charge_station_uzaklik
    print("sarjyeter:", sarj)
    # print("The fuel it consume to return: ", sarj)
    # print("Fuel consumed per unit distance", func)
    # print("HarcanacakSarj:", sarj)

    #


    if(sarj > fcurrent):
        return True
    else:
        return False


def createPatient(dictionary):
    patient = {}
    for key in dictionary:
        if ("patient" in key):
            patient[key] = {}
            patient[key]["id"] = int(''.join(x for x in key if x.isdigit()))
            patient[key]["x"] = dictionary[key]["patient_x"]
            patient[key]["y"] = dictionary[key]["patient_y"]
            patient[key]["z"] = dictionary[key]["patient_z"]
            patient[key]["requirement"] = dictionary[key]["requirement"]
    print(patient)
    return patient

def createHeadquarter(dictionary):
    headquarter = {}
    for key in dictionary:
        if ("headquarter" in key):
            headquarter[key] = {}
            headquarter[key]["x"] = dictionary[key]["patient_x"]
            headquarter[key]["y"] = dictionary[key]["patient_y"]
            headquarter[key]["z"] = dictionary[key]["patient_z"]
    print(headquarter)
    return headquarter


def createHospital(dictionary):
    hospital = {}
    for key in dictionary:
        if ("hospital" in key):
            hospital[key] = {}
            hospital[key]["x"] = dictionary[key]["patient_x"]
            hospital[key]["y"] = dictionary[key]["patient_y"]
            hospital[key]["z"] = dictionary[key]["patient_z"]
            hospital[key]["current_quotas"] = dictionary[key]["current_quotas"]
    print(hospital)
    return hospital


def createChargeStation(dictionary):
    charge_station = {}
    for key in dictionary:
        if ("charge_station" in key):
            charge_station[key] = {}
            charge_station[key]["x"] = dictionary[key]["patient_x"]
            charge_station[key]["y"] = dictionary[key]["patient_y"]
            charge_station[key]["z"] = dictionary[key]["patient_z"]
    print(charge_station)
    return charge_station


def BaslangicKonunum(dictionary, name):
    x = dictionary[name].get("uav_x")
    y = dictionary[name].get("uav_y")
    z = dictionary[name].get("uav_z")
    return x,y,z

def ugv_BaslangicKonunum(dictionary, name):
    x = dictionary[name].get("uxv_x")
    y = dictionary[name].get("uxv_y")
    z = dictionary[name].get("uxv_z")
    return x,y,z

