#!/usr/bin/env python
# -*- coding: utf-8 -*-


import select
import sys
import termios
import tty
import functions
import math
import rospy
from geometry_msgs.msg import Pose, Point
from karmasim_ros_wrapper.msg import VelCmd, UxvStates, Uxv, GPSYaw, PointsOfInterest, PointOfInterest
# --------------------------------zeynep(VehicleLoad eklendi)----------------
from karmasim_ros_wrapper.srv import VehicleStart, VehicleStop, VehicleUnload, VehicleLoad
from std_msgs.msg import Int16, Float32MultiArray, Float32
from sensor_msgs.msg import Range

xHizi = 0
yHizi = 0
zHizi = 0
flag2 = 0
uxv_distance = {}
count2 = 0
flag_gidilecek = True
count = 0

e = """
Communications Failed
"""
MAGIC_CIRCLE = 5
MAGIC_CIRCLE_TOP = 3
MAGIC_CIRCLE_BOTTOM = 3
KomsuKavsaklar = [[]]
KavsakKoordinat = [[]]
GidilecekKoordinatlar = [[]]
TekSeferCalisacakGidilecekKoordKontrol = False
SarjaGit = False
GidilecekNoktaUzakligi = 0.0
uxv_name_ = ""
uxv_type_ = ""
uxvs_name_ = []
iha_json_format = {}
points_of_interest_konumlari = {}
patient = {}
hospital = {}
headquarter = {}
charge_station = {}
MinimumIndexChargeStation = 0
TYPE_HOSPITAL = 0
TYPE_HEADQUARTER = 1
TYPE_PATIENT = 2
TYPE_CHARGE_STATION = 3
REQUIREMENT_NONE = 0
REQUIREMENT_MEDICINE = 1
REQUIREMENT_FOOD = 2
REQUIREMENT_HOSPITAL = 3
CARGO_TYPE_FOOD = 2  # weight of food
CARGO_TYPE_MEDICINE = 1  # weight of medicine
CARGO_TYPE_PATIENT = 5  # weight of patient

LINEAR_Z_MAX = 0
LINEAR_X_MAX = 0
LINEAR_Y_MAX = 0
ANGULAR_Z_MAX = 0

uav_charging_delta_ps = 0

PatienteGidilenler = ""
publishData = []

cargo_unload_distance = 0
cargo_load_distance = 0
charging_point_distance = 0
carpismaKontrol = False
my_id = 0


def getKey():
    tty.setraw(sys.stdin.fileno())
    rlist, _, _ = select.select([sys.stdin], [], [], 0.1)
    if rlist:
        key = sys.stdin.read(1)
    else:
        key = ''

    termios.tcsetattr(sys.stdin, termios.TCSADRAIN, settings)
    return key


def callback(data):
    global PatienteGidilenler
    global publishData
    # rospy.loginfo(rospy.get_caller_id() + "Mesaj: %s", data.data)
    # rospy.loginfo("Mesaj: %s", data.data)
    PatienteGidilenler = data.data
    publishData.append(data.data)


publishKonumlar = []


def callbackKonumlar(data):
    global publishKonumlar
    publishKonumlar.append(data.data)


def LimitleriGetir():
    global LINEAR_Z_MAX
    global LINEAR_X_MAX
    global LINEAR_Y_MAX
    global ANGULAR_Z_MAX
    global uav_charging_delta_ps
    global charging_point_distance
    global cargo_load_distance
    global cargo_unload_distance

    contest_parameters = rospy.get_param('/scenario')
    uav_linear_max_speed = contest_parameters["uav_linear_max_speed"]
    uav_angular_max_speed = contest_parameters["uav_angular_max_speed"]
    uav_charging_delta_ps = contest_parameters["uav_charging_delta_ps"]

    charging_point_distance = contest_parameters["charging_point_distance"]
    cargo_load_distance = contest_parameters["cargo_load_distance"]
    cargo_unload_distance = contest_parameters["cargo_unload_distance"]

    LINEAR_Z_MAX = uav_linear_max_speed
    LINEAR_X_MAX = uav_linear_max_speed
    LINEAR_Y_MAX = uav_linear_max_speed
    ANGULAR_Z_MAX = uav_angular_max_speed


# ihalarin rostan json formatinde dictionariye aktarilmasi

def Uxv_states(data):
    for uxv in data.uxvs:
        iha_json_format[uxv.name] = {}
        iha_json_format[uxv.name]["id"] = int(''.join(x for x in uxv.name if x.isdigit()))
        iha_json_format[uxv.name]['uav_x'] = uxv.pose.position.x
        iha_json_format[uxv.name]['uav_y'] = uxv.pose.position.y
        iha_json_format[uxv.name]['uav_z'] = uxv.pose.position.z
        iha_json_format[uxv.name]["fuel_current"] = uxv.fuel_current
        iha_json_format[uxv.name]["fuel_capacity"] = uxv.FUEL_CAPACITY
        iha_json_format[uxv.name]["cargo_weight"] = uxv.cargo_weight


# patienet dictionarye aktarilmasi

def points_of_interest(data):
    for j in data.pois:
        points_of_interest_konumlari[j.name] = {}
        points_of_interest_konumlari[j.name]['patient_x'] = j.pose.position.x
        points_of_interest_konumlari[j.name]['patient_y'] = j.pose.position.y
        points_of_interest_konumlari[j.name]['patient_z'] = j.pose.position.z
        points_of_interest_konumlari[j.name]['requirement'] = j.requirement
        points_of_interest_konumlari[j.name]['current_quotas'] = j.current_quotas


def printFuel(name):
    fcurrent = iha_json_format[name].get("fuel_current")
    print("Kalan Sarj = ", fcurrent)


def Magic_Distance(x_hizi, y_hizi, z_hizi):
    global MAGIC_CIRCLE
    global MAGIC_CIRCLE_BOTTOM
    global MAGIC_CIRCLE_TOP
    if (x_hizi > 8 and x_hizi <= 10) or (y_hizi > 8 and y_hizi <= 10):
        MAGIC_CIRCLE = 10
    elif (x_hizi > 6 and x_hizi <= 8) or (y_hizi > 6 and y_hizi <= 8):
        MAGIC_CIRCLE = 7
    elif (x_hizi > 4 and x_hizi <= 6) or (y_hizi > 4 and y_hizi <= 6):
        MAGIC_CIRCLE = 5
    elif (x_hizi > 2 and x_hizi <= 4) or (y_hizi > 2 and y_hizi <= 4):
        MAGIC_CIRCLE = 2
    else:
        MAGIC_CIRCLE = 1

    if (z_hizi > 8 and z_hizi <= 10):
        MAGIC_CIRCLE_TOP = 12
        MAGIC_CIRCLE_BOTTOM = 12
    elif (z_hizi > 6 and z_hizi <= 8):
        MAGIC_CIRCLE_TOP = 9
        MAGIC_CIRCLE_BOTTOM = 9
    elif (z_hizi > 4 and z_hizi <= 6):
        MAGIC_CIRCLE_TOP = 6
        MAGIC_CIRCLE_BOTTOM = 6
    elif (z_hizi > 2 and z_hizi <= 4):
        MAGIC_CIRCLE_TOP = 3
        MAGIC_CIRCLE_BOTTOM = 3
    else:
        MAGIC_CIRCLE_TOP = 1
        MAGIC_CIRCLE_BOTTOM = 1


def obstacle_aviodance(x_hizi, y_hizi, z_hizi):
    global flag2
    global flag_gidilecek
    global count, count2
    global iha_json_format
    kontrol = True
    dist_bottom = uxv_distance['distance_bottom']
    dist_rear = uxv_distance['distance_rear']
    dist_left = uxv_distance['distance_left']
    dist_right = uxv_distance['distance_right']
    dist_front = uxv_distance['distance_front']
    dist_top = uxv_distance['distance_top']

    Magic_Distance(xHizi, yHizi, zHizi)
    if dist_bottom >= 5 and dist_top >= 5:
        flag2 = 1
    if flag2 == 1:
        if dist_bottom <= MAGIC_CIRCLE_BOTTOM:
            z_hizi = 4
            print("Bottom girdi")

            flag_gidilecek = False
        else:
            count += 1

        if dist_top <= MAGIC_CIRCLE_TOP:
            z_hizi = -4
            print("top girdi")

            flag_gidilecek = False
        else:
            count += 1
        if dist_rear <= MAGIC_CIRCLE or dist_front <= MAGIC_CIRCLE or dist_right <= MAGIC_CIRCLE or dist_left <= MAGIC_CIRCLE:

            y_hizi *= -1.2
            x_hizi *= -1.2
            z_hizi = 6
            if x_hizi < 2 and y_hizi < 2:
                z_hizi = 1

            flag_gidilecek = False
        # print("Rear girdi")
        else:
            count += 1

        if count == 3:
            flag_gidilecek = True
            kontrol = True
    KonumHizlari(x_hizi, y_hizi, z_hizi, 0, 0, 0)


def sensor_distance_front(data):
    uxv_distance['distance_front'] = data.range


def sensor_distance_bottom(data):
    uxv_distance['distance_bottom'] = data.range


def sensor_distance_left(data):
    uxv_distance['distance_left'] = data.range


def sensor_distance_right(data):
    uxv_distance['distance_right'] = data.range


def sensor_distance_rear(data):
    uxv_distance['distance_rear'] = data.range


def sensor_distance_top(data):
    uxv_distance['distance_top'] = data.range


# Her ihanin Gidilecek koordinatinin uzakliginin belirlenmesi ve hizlarinin ayarlanmasi


def GidilecekKoordinat(gidilecek_x, gidilecek_y, gidilecek_z):
    global TekSeferCalisacakGidilecekKoordKontrol
    global GidilecekKoordinatlar
    global GidilecekNoktaUzakligi
    global carpismaKontrol
    global xHizi
    global yHizi
    global zHizi
    global my_id
    uxv_distance = {}
    printFuel(uxv_name_)
    my_uav_x = iha_json_format[uxv_name_].get("uav_x")
    my_uav_y = iha_json_format[uxv_name_].get("uav_y")
    my_uav_z = iha_json_format[uxv_name_].get("uav_z")
    my_id = int(''.join(x for x in uxv_name_ if x.isdigit()))
    print("Suanki koordinatlarim:", my_uav_x, my_uav_y, my_uav_z)

    # --------------------------------------------Zeynep ------------------------------------------

    if (TekSeferCalisacakGidilecekKoordKontrol == False):
        GidilecekKoordinatlar, GidilecekNoktaUzakligi = functions.NoktalariOlustur([my_uav_x, my_uav_y],
                                                                                   [gidilecek_x, gidilecek_y],
                                                                                   KavsakKoordinat,
                                                                                   KomsuKavsaklar)
        # counter = 0
        # for i in GidilecekKoordinatlar:
        #     counter = counter + 1
        #     if (counter == len(GidilecekKoordinatlar)):
        #         continue
        #     else:
        #         if (my_id < 4):
        #             i[0] = i[0] + 2 * my_id
        #             i[1] = i[1] + 2 * my_id
        #         if (my_id >= 4):
        #             i[0] = i[0] - 2 * my_id
        #             i[1] = i[1] - 2 * my_id
        TekSeferCalisacakGidilecekKoordKontrol = True
    # print("Gidilecek koordinatlar: ", GidilecekKoordinatlar)

    if (len(GidilecekKoordinatlar) > 0):
        # HedefVarisUzaklik = functions.dist([GidilecekKoordinatlar[0][0], GidilecekKoordinatlar[0][1]], [my_uav_x, my_uav_y])
        HedefVarisUzaklik = (GidilecekKoordinatlar[0][0] - my_uav_x) ** 2 + (
                GidilecekKoordinatlar[0][1] - my_uav_y) ** 2 + (gidilecek_z - my_uav_z) ** 2
        HedefVarisUzaklik = math.sqrt(HedefVarisUzaklik)

        # --------------------------------------------Zeynep ------------------------------------------
        if (len(GidilecekKoordinatlar) == 1):
            if (HedefVarisUzaklik < 1):
                GidilecekKoordinatlar.pop(0)
        else:
            if (HedefVarisUzaklik < 3):
                GidilecekKoordinatlar.pop(0)
    if (len(GidilecekKoordinatlar) == 0):
        carpismaKontrol = False

    if (len(GidilecekKoordinatlar) > 0):
        min_distance_x = functions.Uzaklik(GidilecekKoordinatlar[0][0], my_uav_x)
        min_distance_y = functions.Uzaklik(GidilecekKoordinatlar[0][1], my_uav_y)
        min_distance_z = functions.Uzaklik(gidilecek_z, my_uav_z)
        print("Gidilecek Koordinat Uzakligim: ", HedefVarisUzaklik)

        if (my_uav_z > 0.0):
            xHizi = 0
            yHizi = 0
            zHizi = 2
        else:
            xHizi = min_distance_x * 0.3
            yHizi = min_distance_y * 0.3
            zHizi = min_distance_z * -0.3
        KonumHizlari(xHizi, yHizi, zHizi, 0, 0, 0)

    else:

        KonumHizlari(0, 0, 0.001, 0, 0, 0)


def AlcalmaYukselme(gidilecek_z):
    global zHizi
    global carpismaKontrol

    my_uav_z = iha_json_format[uxv_name_].get("uav_z")

    print("Suanki yukseklik: ", my_uav_z)

    uzaklik = (gidilecek_z - my_uav_z) ** 2

    uzaklik = math.sqrt(uzaklik)

    if (uzaklik == 2):
        carpismaKontrol = False

    if (teslimEdildi == False):

        if (uzaklik > 3):

            min_distance_z = functions.Uzaklik(gidilecek_z, my_uav_z)

            if (my_uav_z > 0.0):

                zHizi = -2

            else:

                zHizi = min_distance_z * - 0.3

        KonumHizlari(0, 0, zHizi, 0, 0, 0)


carpismaCounter = 0
tekseferlikz = 0.0
kontrolz = False
counterz = 0


def IhaCarpisma():
    global publishKonumlar
    global carpismaKontrol
    global carpismaCounter
    global kontrolz
    global tekseferlikz
    global counterz

    if (len(iha_json_format) > 0):
        my_uav_id = int(''.join(x for x in uxv_name_ if x.isdigit()))

        my_uav_x = iha_json_format[uxv_name_].get("uav_x")
        my_uav_y = iha_json_format[uxv_name_].get("uav_y")
        my_uav_z = iha_json_format[uxv_name_].get("uav_z")

        for i in iha_json_format:
            if i != uxv_name_:
                uzaklik = functions.dist([my_uav_x, my_uav_y, my_uav_z],
                                         [iha_json_format[i].get("uav_x"), iha_json_format[i].get("uav_y"),
                                          iha_json_format[i].get("uav_z")])
                if (uzaklik < 4):
                    if (my_id < int(''.join(x for x in i if x.isdigit()))):
                        carpismaKontrol = True
            else:
                continue

    # Uzakliga gore hizlarinin verilmesi ve hareket ettirilmesi


def YukselmeAlcalma(hedefz):
    global zHizi

    my_uav_z = iha_json_format[uxv_name_].get("uav_z")

    print("Suanki yukseklik: ", my_uav_z)

    min_distance_z = functions.Uzaklik(hedefz, my_uav_z)
    print("min distance: ", min_distance_z)
    if (my_uav_z > 0.0):

        zHizi = 2
        print("zHizi", zHizi)

    else:
        if (min_distance_z > -5):
            zHizi = 0.5
        else:
            zHizi = 5.0

    KonumHizlari(0, 0, zHizi, 0, 0, 0)


yukseklik = 0.0
yuksekligeUlastim = False


def IHAKalkis():
    global yukseklik
    global yuksekligeUlastim
    global TekSeferCalisacakGidilecekKoordKontrol
    ihacounter = 0
    yukseklikcounter = 0

    my_uav_z = iha_json_format[uxv_name_].get("uav_z")

    yukseklik = 10 + (iha_json_format[uxv_name_]["id"] * 3)

    yukseklik = -(yukseklik)
    print(yukseklik)

    for i in iha_json_format:
        if ("uav" in i and "uav_1" != i and "uav_6" != i and "uav_5" != i and "uav_3" != i):
            ihacounter += 1
            print(i)
        else:
            continue
        if (iha_json_format[i].get("uav_z") < 0 and iha_json_format[i].get("uav_z") <= -10 - (
                iha_json_format[i]["id"] * 3)):
            yukseklikcounter += 1

    print("yukselikcounter: ", yukseklikcounter)
    print("iha counter: ", ihacounter)

    if (my_uav_z >= yukseklik):
        print("Yukseliyor")
        YukselmeAlcalma(yukseklik)

    if (yukseklikcounter == ihacounter):
        yuksekligeUlastim = True


def KonumHizlari(xSpeed, ySpeed, zSpeed, ang_z_speed, ang_x_speed, ang_y_speed):
    print("Konum Hizlari Belirlendi - Konum hizlari fonksiyonu calisti ihalar hareket halinde")

    print("zSpeed", zSpeed)
    target_lin_z_speed = functions.uav_checkLimitSpeed(zSpeed, LINEAR_Z_MAX)
    target_lin_x_speed = functions.uav_checkLimitSpeed(xSpeed, LINEAR_X_MAX)
    target_lin_y_speed = functions.uav_checkLimitSpeed(ySpeed, LINEAR_Y_MAX)
    target_ang_z_speed = functions.uav_checkLimitSpeed(ang_z_speed, ANGULAR_Z_MAX)
    target_ang_x_speed = functions.uav_checkLimitSpeed(ang_x_speed, ANGULAR_Z_MAX)
    target_ang_y_speed = functions.uav_checkLimitSpeed(ang_y_speed, ANGULAR_Z_MAX)

    print(functions.uav_vels(target_lin_z_speed, target_lin_x_speed, target_lin_y_speed, target_ang_z_speed))

    drone_cmd.twist.linear.x = target_lin_x_speed
    drone_cmd.twist.linear.y = target_lin_y_speed
    drone_cmd.twist.linear.z = -target_lin_z_speed
    drone_cmd.twist.angular.x = target_ang_x_speed
    drone_cmd.twist.angular.y = target_ang_y_speed
    drone_cmd.twist.angular.z = target_ang_z_speed
    pub.publish(drone_cmd)


# ---------------------------------------Zeynep --------------------------------------

MinimumIndexHospital = 0

MinimumIndexHeadquarter = 0

merkezeUlasildi = False
hastayaUlasildi = False
loadKontrol = False
unloadKontrol = False
alcalmaKontrol = False
HastaSecildi = False

x_point = 0.0
y_point = 0.0
z_point = 0.0

x_patient = 0.0
y_patient = 0.0
z_patient = 0.0

hastaKontrol = False
alcalmaKontrol2 = False
teslimEdildi = False


def HastaBul(aracKontrol):
    global HastaSecildi
    global PatienteGidilenler
    global publishData
    global alcalmaKontrol2
    global teslimEdildi
    global Sayac

    teslimEdildi = False
    alcalmaKontrol2 = False
    SecilenPatient = ""

    for i in publishData:
        name = "patient_" + str(i)
        if name in patient:
            patient.pop(name, None)

    Sayac = 0
    for i in patient:
        if (aracKontrol == "IHA"):
            if (patient[i].get("requirement") != REQUIREMENT_HOSPITAL):
                SecilenPatient = i
                break
        else:
            SecilenPatient = i

    HastaSecildi = True

    return SecilenPatient


Sayac = 0


def yakinNoktayiBul(patientNo):
    global MinimumIndexHospital
    global MinimumIndexHeadquarter
    global merkezeUlasildi
    global alcalmaKontrol
    global counterz
    global x_point
    global y_point
    global z_point
    global hastaKontrol
    global Sayac
    global TekSeferCalisacakGidilecekKoordKontrol
    library = ""
    keyNokta = ""

    counterz = 0

    if (patient[patientNo]["requirement"] == REQUIREMENT_HOSPITAL):
        print("IHA Hasta tasiyamaz başka bir yer secin")
        hastaKontrol = True

    if (hastaKontrol == False):
        if (patient[patientNo]["requirement"] == REQUIREMENT_MEDICINE):
            minhospital = (patient[patientNo]["x"] - hospital["hospital_1"].get("x")) ** 2 + (
                    patient[patientNo]["y"] - hospital["hospital_1"].get("y")) ** 2
            minhospital = math.sqrt(minhospital)

            for i in hospital:
                uzaklik = (patient[patientNo]["x"] - hospital[i].get("x")) ** 2 + (
                        patient[patientNo]["y"] - hospital[i].get("y")) ** 2
                uzaklik = math.sqrt(uzaklik)
                if uzaklik <= minhospital:
                    minhospital = uzaklik
                    MinimumIndexHospital = i
            print(MinimumIndexHospital)
            library = hospital
            keyNokta = MinimumIndexHospital

        if (patient[patientNo]["requirement"] == REQUIREMENT_FOOD):
            minheadquarter = math.sqrt(
                (patient[patientNo]["x"] - headquarter["headquarter_1"].get("x")) ** 2 + (
                        patient[patientNo]["y"] - headquarter["headquarter_1"].get("y")) ** 2)
            for i in headquarter:
                uzaklik = (patient[patientNo]["x"] - headquarter[i].get("x")) ** 2 + (
                        patient[patientNo]["y"] - headquarter[i].get("y")) ** 2
                uzaklik = math.sqrt(uzaklik)
                print(uzaklik)
                print(minheadquarter)
                if uzaklik <= minheadquarter:
                    minheadquarter = uzaklik
                    MinimumIndexHeadquarter = i

            library = headquarter
            keyNokta = MinimumIndexHeadquarter
            print(MinimumIndexHeadquarter)

        x_point = library[keyNokta]["x"]
        y_point = library[keyNokta]["y"]
        z_point = library[keyNokta]["z"] - cargo_load_distance / 1.50

        uzaklik2 = (iha_json_format[uxv_name_].get("uav_x") - library[keyNokta]["x"]) ** 2 + (
                iha_json_format[uxv_name_].get("uav_y") - library[keyNokta]["y"]) ** 2 + (
                           iha_json_format[uxv_name_].get("uav_z") - library[keyNokta]["z"]) ** 2
        uzaklik2 = math.sqrt(uzaklik2)

        print("Uzaklik2:", uzaklik2)
        counter = 0
        if (Sayac == 0):
            TekSeferCalisacakGidilecekKoordKontrol = False
            counter = 1
            Sayac = 1

        if (len(GidilecekKoordinatlar) == 0 and counter == 0):
            print("Gidilecek Koordiantlar 0")
            alcalmaKontrol = True
            counter = 1

        if (uzaklik2 <= cargo_load_distance):
            print("Uzaklik cargo_load_distance altına düştü!!")
            merkezeUlasildi = True


def malzemeAl(patientNo):
    global loadKontrol
    global TekSeferCalisacakGidilecekKoordKontrol
    global counterz
    cargo_type = ""
    amount_number = 1
    source_poi = ""

    uzaklik = 0
    if (patient[patientNo]["requirement"] == REQUIREMENT_FOOD):
        cargo_type = REQUIREMENT_FOOD
        source_poi = MinimumIndexHeadquarter

    if (patient[patientNo]["requirement"] == REQUIREMENT_MEDICINE):
        cargo_type = REQUIREMENT_MEDICINE
        source_poi = MinimumIndexHospital

    rospy.wait_for_service('/karmasim_node/vehicle_load')
    req = rospy.ServiceProxy('/karmasim_node/vehicle_load', VehicleLoad)
    res = req(uxv_name_, source_poi, cargo_type, amount_number)
    print('load result: %s\t message: %s ' % (res.success, res.message))
    print(res.success)

    counter = 0

    if (res.success == True and counter == 0):
        loadKontrol = True
        TekSeferCalisacakGidilecekKoordKontrol = False
        counter = 1
        counterz = 0


def hastayaGit(patientNo):
    global x_patient
    global y_patient
    global z_patient
    global alcalmaKontrol2
    global hastayaUlasildi

    x_patient = patient[patientNo]["x"]
    y_patient = patient[patientNo]["y"]
    z_patient = patient[patientNo]["z"] - 2

    uzaklik = (iha_json_format[uxv_name_].get("uav_x") - x_patient) ** 2 + (
            iha_json_format[uxv_name_].get("uav_y") - y_patient) ** 2 + (
                      iha_json_format[uxv_name_].get("uav_z") - z_patient) ** 2
    uzaklik = math.sqrt(uzaklik)

    uzaklik2 = (iha_json_format[uxv_name_].get("uav_x") - x_patient) ** 2 + (
            iha_json_format[uxv_name_].get("uav_y") - y_patient) ** 2
    uzaklik2 = math.sqrt(uzaklik2)

    if (len(GidilecekKoordinatlar) == 0 and uzaklik2 <= cargo_unload_distance / 1.25):
        alcalmaKontrol2 = True

    if (uzaklik <= cargo_unload_distance / 1.25):
        print("uzaklik 8den kucuk")
        hastayaUlasildi = True


def malzemeBirak(patientNo):
    global unloadKontrol
    global HastaSecildi
    global loadKontrol
    global alcalmaKontrol
    global hastayaUlasildi
    global merkezeUlasildi
    global alcalmaKontrol2
    global teslimEdildi

    target_poi = patientNo
    amount_number = 1
    cargo_type = ""

    if (patient[patientNo]["requirement"] == REQUIREMENT_FOOD):
        cargo_type = REQUIREMENT_FOOD
    if (patient[patientNo]["requirement"] == REQUIREMENT_MEDICINE):
        cargo_type = REQUIREMENT_MEDICINE

    rospy.wait_for_service('/karmasim_node/vehicle_unload')
    req = rospy.ServiceProxy('/karmasim_node/vehicle_unload', VehicleUnload)
    res = req(uxv_name_, target_poi, cargo_type, amount_number)
    print('unload result: %s\t message: %s ' % (res.success, res.message))

    if (res.success == True):
        HastaSecildi = False
        loadKontrol = False
        alcalmaKontrol = False
        unloadKontrol = False
        hastayaUlasildi = False
        alcalmaKontrol2 = False
        merkezeUlasildi = False
        teslimEdildi = True
        patient.pop(patientNo, None)


# ---------------------------------------- Zeynep ---------------------------------------------


def SarjYetiyorMu():
    global SarjaGit
    global MinimumIndexChargeStation
    global TekSeferCalisacakGidilecekKoordKontrol
    global Sayac

    minstation = 0

    FirstStation = False

    for i in charge_station:
        if (FirstStation == False):
            minstation = math.sqrt((iha_json_format[uxv_name_].get("uav_x") - charge_station[i].get("x")) ** 2 + (
                    iha_json_format[uxv_name_].get("uav_y") - charge_station[i].get("y")) ** 2)
            FirstStation = True
        uzaklik2 = (iha_json_format[uxv_name_].get("uav_x") - charge_station[i].get("x")) ** 2 + (
                iha_json_format[uxv_name_].get("uav_y") - charge_station[i].get("y")) ** 2

        uzaklik2 = math.sqrt(uzaklik2)
        if uzaklik2 < minstation:
            minstation = uzaklik2
            MinimumIndexChargeStation = i

    print("minsarj: ", minstation)

    SarjaGit = functions.chargeStation(uxv_name_, iha_json_format, float(LINEAR_X_MAX) / 9.0, minstation)

    if (SarjaGit == True):
        TekSeferCalisacakGidilecekKoordKontrol = False


sarjYukseklik = False


def SarjKontrol():
    global SarjaGit
    global TekSeferCalisacakGidilecekKoordKontrol
    global Sayac
    global sarjYukseklik
    global alcalmaKontrol2
    global alcalmaKontrol
    global MinimumIndexChargeStation

    SarjOldu = functions.SarjHaber(uxv_name_, iha_json_format)

    uzaklik = functions.dist([iha_json_format[uxv_name_].get("uav_x"), iha_json_format[uxv_name_].get("uav_y")],
                             [charge_station[MinimumIndexChargeStation]["x"],
                              charge_station[MinimumIndexChargeStation]["y"]])
    print("sarj uzaklik ", uzaklik)
    if (uzaklik < 3):
        sarjYukseklik = True

    if (SarjOldu == True):
        SarjaGit = False
        sarjYukseklik = False
        alcalmaKontrol2 = False
        alcalmaKontrol = False
        Sayac = 0
        TekSeferCalisacakGidilecekKoordKontrol = False


if __name__ == "__main__":

    settings = termios.tcgetattr(sys.stdin)
    rospy.init_node('airsim_drone_teleop')
    pub = rospy.Publisher('uav_cmd', VelCmd, queue_size=10)
    drone_cmd = VelCmd()

    uxv_name_ = rospy.get_param('~uxv_name', "algan")
    uxv_type_ = rospy.get_param('~uxv_type', 0)

    rospy.Subscriber('/karmasim_node/uxv_states', UxvStates, Uxv_states)
    rospy.Subscriber('/karmasim_node/points_of_interest', PointsOfInterest, points_of_interest)

    HastayaGidiyorum = rospy.Publisher('Hastam', Int16, queue_size=10)
    rospy.Subscriber("Hastam", Int16, callback)

    # KonumGonder = rospy.Publisher('Konum', Float32MultiArray, queue_size=10)
    # rospy.Subscriber("Konum", Float32MultiArray, callbackKonumlar)

    rospy.Subscriber('/karmasim_node/' + uxv_name_ + '/distance/dist_front', Range, sensor_distance_front)
    rospy.Subscriber('/karmasim_node/' + uxv_name_ + '/distance/dist_bottom', Range, sensor_distance_bottom)
    rospy.Subscriber('/karmasim_node/' + uxv_name_ + '/distance/dist_front', Range, sensor_distance_front)
    rospy.Subscriber('/karmasim_node/' + uxv_name_ + '/distance/dist_rear', Range, sensor_distance_rear)
    rospy.Subscriber('/karmasim_node/' + uxv_name_ + '/distance/dist_left', Range, sensor_distance_left)
    rospy.Subscriber('/karmasim_node/' + uxv_name_ + '/distance/dist_right', Range, sensor_distance_right)
    rospy.Subscriber('/karmasim_node/' + uxv_name_ + '/distance/dist_top', Range, sensor_distance_top)

    KomsuKavsaklar = functions.KomsuKavsakGetir()
    KavsakKoordinat = functions.KavsakNoktaGetir()
    LimitleriGetir()

    # ---------------------------------------- Zeynep ---------------------------------------------

    # patientNo = "patient_1"

    # ---------------------------------------- Zeynep ---------------------------------------------
    try:

        rospy.wait_for_service('/karmasim_node/vehicle_start')
        request = rospy.ServiceProxy('/karmasim_node/vehicle_start', VehicleStart)
        result = request(uxv_name_)
        BaslangicKonum = False
        YuvayaDon = False
        patientNo = ""
        if (len(iha_json_format) != 0):
            baslangic_x, baslangic_y, baslangic_z = functions.BaslangicKonunum(iha_json_format, uxv_name_)
            BaslangicKonum = True
        while 1:
            key = getKey()
            if (len(iha_json_format) != 0):
                if (BaslangicKonum == False):
                    baslangic_x, baslangic_y, baslangic_z = functions.BaslangicKonunum(iha_json_format, uxv_name_)
                    BaslangicKonum = True
                if (len(patient) != 0):
                    if (len(charge_station) != 0):
                        if (len(hospital) != 0):
                            if (len(headquarter) != 0):
                                my_id = int(''.join(x for x in uxv_name_ if x.isdigit()))
                                print(my_id)
                                if (PatienteGidilenler != patientNo):
                                    patient.pop(PatienteGidilenler, None)
                                # if flag_gidilecek == True:
                                print("BaslangicKoordinatlarim", baslangic_x, baslangic_y, baslangic_z)
                                if (SarjaGit == False and len(charge_station) != 0):
                                    if (yuksekligeUlastim == False):
                                        IHAKalkis()
                                    else:
                                        if (HastaSecildi == False):
                                            patientNo = HastaBul("IHA")
                                        if (patientNo != ""):
                                            HastayaGidiyorum.publish(patient[patientNo]["id"])

                                            if (hastaKontrol == True):
                                                print("IHA icin baska nokta secin")
                                            else:
                                                if (loadKontrol == False):
                                                    print("Patient: ", patientNo)
                                                    yakinNoktayiBul(patientNo)
                                                    if (alcalmaKontrol == False):
                                                        IhaCarpisma()
                                                        if (carpismaKontrol == False):
                                                            GidilecekKoordinat(x_point, y_point, -17)
                                                        if (carpismaKontrol == True):
                                                            GidilecekKoordinat(x_point, y_point, -17 - my_id * 4)
                                                    if (alcalmaKontrol == True):
                                                        # IhaCarpisma()
                                                        if (carpismaKontrol == False):
                                                            AlcalmaYukselme(z_point)
                                                        if (carpismaKontrol == True):
                                                            AlcalmaYukselme(z_point - 5)
                                                    if (merkezeUlasildi == True):
                                                        malzemeAl(patientNo)
                                                elif (loadKontrol == True):
                                                    if (unloadKontrol == False):
                                                        hastayaGit(patientNo)
                                                        if (alcalmaKontrol2 == False):
                                                            IhaCarpisma()
                                                            if (carpismaKontrol == False):
                                                                GidilecekKoordinat(x_patient, y_patient, -25)
                                                            if (carpismaKontrol == True):
                                                                GidilecekKoordinat(x_patient, y_patient,
                                                                                   -25 - 4 * my_id)
                                                        if (alcalmaKontrol2 == True):
                                                            # IhaCarpisma()
                                                            if (carpismaKontrol == False):
                                                                AlcalmaYukselme(z_patient)
                                                            if (carpismaKontrol == True):
                                                                AlcalmaYukselme(z_patient - 5)
                                                        if (hastayaUlasildi == True):
                                                            malzemeBirak(patientNo)
                                        else:
                                            print("Hastalar Bitti Yuvaya Donuyoruz")
                                            if (YuvayaDon == False):
                                                TekSeferCalisacakGidilecekKoordKontrol = False
                                                YuvayaDon = True
                                            GidilecekKoordinat(baslangic_x, baslangic_y, baslangic_z - 7)

                                    # ---------------------------------------- Zeynep ---------------------------------------------

                                    SarjYetiyorMu()
                                elif (SarjaGit == True):
                                    if (patientNo != ""):
                                        HastayaGidiyorum.publish(patient[patientNo]["id"])

                                    if (sarjYukseklik == False):
                                        # degisti
                                        # IhaCarpisma()
                                        if (carpismaKontrol == False):
                                            GidilecekKoordinat(charge_station[MinimumIndexChargeStation].get('x'),
                                                               charge_station[MinimumIndexChargeStation].get('y'),
                                                               -25)
                                        if (carpismaKontrol == True):
                                            GidilecekKoordinat(x_point, y_point, -25 - my_id * 4)

                                    if (sarjYukseklik == True):
                                        print("sarjYukseklik == True")
                                        if (carpismaKontrol == False):
                                            AlcalmaYukselme(charge_station[MinimumIndexChargeStation].get('z') - 4)
                                        if (carpismaKontrol == True):
                                            AlcalmaYukselme(z_patient - 5)
                                        AlcalmaYukselme(charge_station[MinimumIndexChargeStation].get('z') - 4)
                                    SarjKontrol()
                                    print("SarjaGidiliyor")
                                # obstacle_aviodance(xHizi, yHizi, zHizi)
                                # count = 0

                            else:
                                headquarter = functions.createHeadquarter(points_of_interest_konumlari)
                        else:
                            hospital = functions.createHospital(points_of_interest_konumlari)
                    else:
                        charge_station = functions.createChargeStation(points_of_interest_konumlari)
                else:
                    patient = functions.createPatient(points_of_interest_konumlari)

            if (key == '\x03'):
                request = rospy.ServiceProxy('/karmasim_node/vehicle_stop', VehicleStop)
                break

    except:

        print('Exception:' + e)

    finally:

        drone_cmd = VelCmd()

        drone_cmd.twist.linear.x = 0
        drone_cmd.twist.linear.y = 0
        drone_cmd.twist.linear.z = 0
        drone_cmd.twist.angular.x = 0
        drone_cmd.twist.angular.y = 0
        drone_cmd.twist.angular.z = 0
        pub.publish(drone_cmd)
        request = rospy.ServiceProxy('/karmasim_node/vehicle_stop', VehicleStop)
        result = request(uxv_name_)

    termios.tcsetattr(sys.stdin, termios.TCSADRAIN, settings)





