#!/usr/bin/env python
# -*- coding: utf-8 -*-

import select
import sys
import termios
import tty
import rospy
import sys
import math
import functions
import time
from karmasim_ros_wrapper.msg import CarControls, UxvStates, Uxv, PointsOfInterest, PointOfInterest
from karmasim_ros_wrapper.srv import VehicleStart, VehicleStop, VehicleUnload, VehicleLoad
from nav_msgs.msg import Odometry
from std_msgs.msg import Int16, Float32MultiArray, Float32
from tf.transformations import euler_from_quaternion, quaternion_from_euler
from sensor_msgs.msg import Range



ugv_distance = {}
flag = False
flag_Deneme = False
THROTTLE_STEP_SIZE = 0.2
STEERING_STEP_SIZE = 0.2

MAGIC_CIRCLE = 6
MAGIC_CIRCLE_CENTER = 6
angleHizi = 0.0
ugv_json_format = {}
points_of_interest_konumlari = {}
patient = {}
hospital = {}
headquarter = {}
charge_station = {}

ugv_charging_delta_ps = 0
target_angle = 0.0
MAX_THROTTLE = 0
MAX_STEERING = 0
yaw = 0
roll = 0
pitch = 0
MinimumIndexChargeStation = 0
GidilecekKoordinatlar = [[]]
KomsuKavsaklar = [[]]
KavsakKoordinat = [[]]
veriler = []
uxvs_name_ = []
uxv_distance={}
uxv_name_ = ""
pois_name_ = ""
uxv_type_ = ""

TekSeferCalisacakGidilecekKoordKontrol = False
SarjaGit = False

TYPE_HOSPITAL = 0
TYPE_HEADQUARTER = 1
TYPE_PATIENT = 2
TYPE_CHARGE_STATION = 3
REQUIREMENT_NONE = 0
REQUIREMENT_MEDICINE = 1
REQUIREMENT_FOOD = 2
REQUIREMENT_HOSPITAL = 3
CARGO_TYPE_FOOD = 2  # weight of food
CARGO_TYPE_MEDICINE = 1  # weight of medicine
CARGO_TYPE_PATIENT = 5  # weight of patient
xHizi = 0.0
angleHizi = 0.0
GidilecekNoktaUzakligi = 0

cargo_unload_distance = 0
cargo_load_distance = 0
charging_point_distance = 0

flagCarp = True
yonKontrol = True
counter = 0
flag_gidilecek = True

BaslangicSiralamaKontrol = False


msg = """
Control the Car. 
---------------------------
Moving around:
        w
   a    s    d
        x

w/s   : increase/decrease throttle ( ~ 2.0)
a/d   : increase/decrease angular velocity ( ~ 1.0)
x     : brake
space : handbrake/release handbrake
l     : load medicine/food/patient
u     : unload medicine/food/patient

CTRL-C to quit
"""

e = """
Communications Failed
"""

def callback(data):
    global PatienteGidilenler
    global publishData
    # rospy.loginfo(rospy.get_caller_id() + "Mesaj: %s", data.data)
    # rospy.loginfo("Mesaj: %s", data.data)
    PatienteGidilenler = data.data
    publishData.append(data.data)




def getOdometry(data):
    global yaw
    global roll
    global pitch

    (roll, pitch, yaw) = euler_from_quaternion(
        [data.pose.pose.orientation.x, data.pose.pose.orientation.y, data.pose.pose.orientation.z,
         data.pose.pose.orientation.w])


def Uxv_states(data):
    for uxv in data.uxvs:
        ugv_json_format[uxv.name] = {}
        ugv_json_format[uxv.name]["id"] = int(''.join(x for x in uxv.name if x.isdigit()))
        ugv_json_format[uxv.name]['uxv_x'] = uxv.pose.position.x
        ugv_json_format[uxv.name]['uxv_y'] = uxv.pose.position.y
        ugv_json_format[uxv.name]['uxv_z'] = uxv.pose.position.z
        ugv_json_format[uxv.name]["fuel_current"] = uxv.fuel_current
        ugv_json_format[uxv.name]["fuel_capacity"] = uxv.FUEL_CAPACITY
        ugv_json_format[uxv.name]["cargo_weight"] = uxv.cargo_weight


def LimitleriGetir():
    global MAX_THROTTLE
    global MAX_STEERING
    global ugv_charging_delta_ps
    contest_parameters = rospy.get_param('/scenario')
    ugv_max_throttle = contest_parameters["ugv_max_throttle"]
    ugv_max_steering = contest_parameters["ugv_max_steering"]
    charging_point_distance = contest_parameters["charging_point_distance"]
    cargo_load_distance = contest_parameters["cargo_load_distance"]
    cargo_unload_distance = contest_parameters["cargo_unload_distance"]
    MAX_THROTTLE = ugv_max_throttle
    MAX_STEERING = ugv_max_steering
    contest_parameters = rospy.get_param('/scenario')
    world_boundaries = contest_parameters["world_boundaries"]
    ugv_charging_delta_ps = contest_parameters["ugv_charging_delta_ps"]
    print('World Boundaries')
    print(world_boundaries)

# patienet dictionarye aktarilmasi
def points_of_interest(data):
    for j in data.pois:
        points_of_interest_konumlari[j.name] = {}
        points_of_interest_konumlari[j.name]['patient_x'] = j.pose.position.x
        points_of_interest_konumlari[j.name]['patient_y'] = j.pose.position.y
        points_of_interest_konumlari[j.name]['patient_z'] = j.pose.position.z
        points_of_interest_konumlari[j.name]['requirement'] = j.requirement
        points_of_interest_konumlari[j.name]['current_quotas'] = j.current_quotas


def sensor_distance_back_center(data):
    uxv_distance['distance_back_center'] = data.range


def sensor_distance_front_center(data):
    uxv_distance['distance_front_center'] = data.range


def sensor_distance_front_left(data):
    uxv_distance['distance_front_left'] = data.range


def sensor_distance_front_right(data):
    uxv_distance['distance_front_right'] = data.range

def BaslangicSiralamasi():
    global BaslangicSiralamaKontrol
    myid = ugv_json_format[uxv_name_].get("id")
    print("IDim : ", myid)
    if(myid == 1):
        time.sleep(1)
    else:
        time.sleep(myid*10)
    BaslangicSiralamaKontrol = True


def obstacle_aviodance(hiz, yon):
    global flag_gidilecek
    global flagCarp
    global xHizi
    global angleHizi
    global counter
    dist_back = uxv_distance['distance_back_center']
    dist_front = uxv_distance['distance_front_center']
    dist_left = uxv_distance['distance_front_left']
    dist_right = uxv_distance['distance_front_right']

    if (dist_left <= MAGIC_CIRCLE_CENTER or dist_right <= MAGIC_CIRCLE_CENTER) and (dist_front <= MAGIC_CIRCLE_CENTER):
        hiz = -1
        yon = (-4) * yon
        print("***********************front and left right girdi")

    elif (dist_left <= MAGIC_CIRCLE_CENTER or dist_right <= MAGIC_CIRCLE_CENTER) and (dist_back <= MAGIC_CIRCLE_CENTER):
        hiz = 1
        yon = (-4) * yon
        print("***********************back and left right girdi")
    else :
        if dist_back <= MAGIC_CIRCLE_CENTER:
            hiz = 0.5
            # yon=-0.4
            flag_gidilecek = False
            print("***********************back girdi")
        else:
            counter += 1
        if dist_front <= MAGIC_CIRCLE_CENTER:
            hiz = -0.5
            # yon= 0.4
            flag_gidilecek = False
            print("***********************front girdi")
        else:
            counter += 1
        if dist_left <= MAGIC_CIRCLE_CENTER or dist_right <= MAGIC_CIRCLE_CENTER:
            yon = (-4) * yon
            # hiz = -0.2
            flag_gidilecek = False
            print("***********************left-right girdi")
        else:
            counter += 1
        if counter == 3:
            flag_gidilecek = True






    yon = functions.ugv_checkLimitSteering(yon, 2)
    hiz = functions.ugv_checkLimitThrottle(hiz, 3)
    KonumHizlari(hiz, yon)


def getKey():
    tty.setraw(sys.stdin.fileno())
    rlist, _, _ = select.select([sys.stdin], [], [], 0.1)
    if rlist:
        key = sys.stdin.read(1)
    else:
        key = ''

    termios.tcsetattr(sys.stdin, termios.TCSADRAIN, settings)
    return key



def GidilecekKoordinat(gidilecek_x, gidilecek_y):
    global TekSeferCalisacakGidilecekKoordKontrol
    global tekSefer
    global target_angle
    global flag
    global yaw
    global xHizi
    global angleHizi
    global GidilecekNoktaUzakligi
    global GidilecekKoordinatlar
    global flag_Deneme


    # print("Suanki koordinatlarim")
    my_uav_x = ugv_json_format[uxv_name_].get("uxv_x")
    my_uav_y = ugv_json_format[uxv_name_].get("uxv_y")
    # print(my_uav_x)
    # print(my_uav_y)
    # Uzakligim = functions.dist([gidilecek_x, gidilecek_y], [my_uav_x, my_uav_y])

    if (TekSeferCalisacakGidilecekKoordKontrol == False):
        GidilecekKoordinatlar, GidilecekNoktaUzakligi = functions.NoktalariOlustur([my_uav_x, my_uav_y], [gidilecek_x, gidilecek_y], KavsakKoordinat, KomsuKavsaklar)
        TekSeferCalisacakGidilecekKoordKontrol = True
    print(GidilecekKoordinatlar)
    if (len(GidilecekKoordinatlar) > 0):
        HedefVarisUzaklik = functions.dist([GidilecekKoordinatlar[0][0], GidilecekKoordinatlar[0][1]], [my_uav_x, my_uav_y])

        if (HedefVarisUzaklik < 5):
            GidilecekKoordinatlar.pop(0)
    if (len(GidilecekKoordinatlar) > 0):
        xHizi = 0

        # print("Gidilecek koordinatina uzakligim")

        min_distance_x = functions.dist([GidilecekKoordinatlar[0][0], GidilecekKoordinatlar[0][1]], [my_uav_x, my_uav_y])

        # print(min_distance_x)
        # print("gidilecek koordinat: ", GidilecekKoordinatlar[0][0], GidilecekKoordinatlar[0][1])
        son_x = GidilecekKoordinatlar[0][0] - my_uav_x
        son_y = GidilecekKoordinatlar[0][1] - my_uav_y
        target_angle = math.atan2((son_y), (son_x))
        if (yaw < -3.14 and target_angle > 3.14):

            b = target_angle + yaw
            DonulecekDeger = b % 3.14
            xHizi = 0.15

        else:
            print("gidilecek deger: ", target_angle)
            print("bas acim: ", yaw)
            if (min_distance_x > 70):
                xHizi = 0.50;
            elif (min_distance_x > 40):
                xHizi = 0.45;
            elif (min_distance_x > 20):
                xHizi = 0.23;
            elif (min_distance_x > 0):
                xHizi = min_distance_x * 0.02

            # print("xHizim=", xHizi)

            DonulecekDeger = (target_angle - yaw)
        if(DonulecekDeger < -3.14 or DonulecekDeger > 3.14):
            DonulecekDeger = DonulecekDeger % 3.14
        if(DonulecekDeger - 3.14 > -1.57):
            DonulecekDeger = DonulecekDeger - 3.14
            if ((target_angle -yaw) >1.57 and  (target_angle -yaw)<3.15) or ((target_angle -yaw) <-1.57 and     (target_angle -yaw)>-3.15):
                DonulecekDeger = (target_angle - yaw)
        angleHizi = DonulecekDeger

        print("angleHizi=", angleHizi)

        print(xHizi)
        # obstacle_aviodance(xHizi,angleHizi)

        if(BaslangicSiralamaKontrol):
            KonumHizlari(xHizi, angleHizi)
        else:
            BaslangicSiralamasi()
    else:
        KonumHizlari(0, 0)



def KonumHizlari(hiz, yon):
    target_throttle = hiz
    target_steering = yon

    car_cmd.brake = 0

    if target_throttle > 0:
        car_cmd.manual = False
        if car_cmd.manual_gear != 1:
            car_cmd.manual_gear = 1
    elif (target_throttle < 0):
        car_cmd.manual = True
        car_cmd.manual_gear = -1
    else:
        target_throttle = 0
        car_cmd.brake = 1
    # print("kontrol2")

    car_cmd.throttle = target_throttle
    car_cmd.steering = target_steering
    pub.publish(car_cmd)
    # print("kontrol2")

def printFuel(name):
    fcurrent = ugv_json_format[name].get("fuel_current")
    print("Kalan Sarj = ", fcurrent)


MinimumIndexHospital = 0

MinimumIndexHeadquarter = 0

merkezeUlasildi = False
hastayaUlasildi = False
loadKontrol = False
unloadKontrol = False
HastaSecildi = False

x_point = 0.0
y_point = 0.0
z_point = 0.0

x_patient = 0.0
y_patient = 0.0
z_patient = 0.0
publishData = []

teslimEdildi = False
HastaTasiyacak = False

def HastaBul():
    global HastaSecildi
    global PatienteGidilenler
    global publishData
    global teslimEdildi
    global Sayac
    global HastaTasiyacak

    teslimEdildi = False
    SecilenPatient = ""

    for i in publishData:
        name = "patient_" + str(i)
        if name in patient:
            patient.pop(name, None)

    Sayac = 0
    Secim = False
    for i in patient:
        if (patient[i].get("requirement") == REQUIREMENT_HOSPITAL):
            SecilenPatient = i
            Secim = True
            HastaTasiyacak = True
            break
    if (Secim == False):
        for i in patient:
            if (patient[i].get("requirement") != REQUIREMENT_HOSPITAL and patient[i].get("z") > -1):
                SecilenPatient = i
                break

    HastaSecildi = True
    return SecilenPatient


Sayac = 0

def SarjYetiyorMu():
    global SarjaGit
    global MinimumIndexChargeStation
    global TekSeferCalisacakGidilecekKoordKontrol
    FirstStation = False
    for i in charge_station:
        print(i)
        if (FirstStation is False and charge_station[i].get("z") > -1):
            minstation = math.sqrt((ugv_json_format[uxv_name_].get("uxv_x") - charge_station[i].get("x")) ** 2 + (
                    ugv_json_format[uxv_name_].get("uxv_y") - charge_station[i].get("y")) ** 2 )
            FirstStation = True
            MinimumIndexChargeStation = i
        if(FirstStation == True):
            if (charge_station[i].get("z") > -1):
                uzaklik2 = (ugv_json_format[uxv_name_].get("uxv_x") - charge_station[i].get("x")) ** 2 + (
                        ugv_json_format[uxv_name_].get("uxv_y") - charge_station[i].get("y")) ** 2
                uzaklik2 = math.sqrt(uzaklik2)
            else:
                uzaklik2 = 999999
            if uzaklik2 < minstation:
                minstation = uzaklik2
                MinimumIndexChargeStation = i

        print(minstation)
    print(MinimumIndexChargeStation)
    SarjYolKoordinatlari, SarjYolUzakligi = functions.NoktalariOlustur(
        [ugv_json_format[uxv_name_].get("uxv_x"), ugv_json_format[uxv_name_].get("uxv_y")],
        [charge_station[MinimumIndexChargeStation].get("x"), charge_station[MinimumIndexChargeStation].get("y")],
        KavsakKoordinat, KomsuKavsaklar)
    print("SarjYolUzakligi: ", SarjYolUzakligi)
    SarjaGit = functions.chargeStation(uxv_name_, ugv_json_format, MAX_THROTTLE / 6, SarjYolUzakligi)
    if (SarjaGit == True):
        TekSeferCalisacakGidilecekKoordKontrol = False


def SarjKontrol():
    global SarjaGit
    global TekSeferCalisacakGidilecekKoordKontrol
    SarjOldu = functions.SarjHaber(uxv_name_, ugv_json_format)

    if (SarjOldu == True):
        SarjaGit = False
        TekSeferCalisacakGidilecekKoordKontrol = False


MinimumIndexHospital = 0
MinimumIndexHeadquarter = 0

hastaTasinacak = False
noktayaUlasildi = False
hastayaUlasildi = False
loadKontrol = False
unloadKontrol = False
gorevKontrol = False

x_point = 0.0
y_point = 0.0

x_patient = 0.0
y_patient = 0.0


def yakinNoktayiBul(patientNo):
    global MinimumIndexHospital
    global MinimumIndexHeadquarter
    global hastaTasinacak
    global noktayaUlasildi
    global alcalmaKontrol
    global x_point
    global y_point
    global TekSeferCalisacakGidilecekKoordKontrol
    global gorevKontrol

    library = ""
    keyNokta = ""

    if (patient[patientNo]["z"] < -1.0):
        print("IKA bu noktaya gidemez")
        x_point = ugv_json_format[uxv_name_].get("uxv_x") #yerlerinde bekliyorlar
        y_point = ugv_json_format[uxv_name_].get("uxv_y") #yerlerinde bekliyorlar
        gorevKontrol = True

    else:
        if (patient[patientNo]["requirement"] == REQUIREMENT_HOSPITAL):
            print("Burada hospital1")
            library = patient
            keyNokta = patientNo
            hastaTasinacak = True
            print("Burada hospital2")
            minhospital = (ugv_json_format[uxv_name_].get("uxv_x") - hospital["hospital_1"].get("x")) ** 2 + (
                    ugv_json_format[uxv_name_].get("uxv_y") - hospital["hospital_1"].get("y")) ** 2
            minhospital = math.sqrt(minhospital)
            for i in hospital:
                uzaklik = (ugv_json_format[uxv_name_].get("uxv_x") - hospital[i].get("x")) ** 2 + (
                        ugv_json_format[uxv_name_].get("uxv_y") - hospital[i].get("x")) ** 2
                uzaklik = math.sqrt(uzaklik)
                if uzaklik <= minhospital:
                    minhospital = uzaklik
                    MinimumIndexHospital = i

        if (patient[patientNo]["requirement"] == REQUIREMENT_MEDICINE):
            minhospital = (ugv_json_format[uxv_name_].get("uxv_x") - hospital["hospital_1"].get("x")) ** 2 + (
                    ugv_json_format[uxv_name_].get("uxv_y") - hospital["hospital_1"].get("y")) ** 2
            minhospital = math.sqrt(minhospital)
            for i in hospital:
                uzaklik = (ugv_json_format[uxv_name_].get("uxv_x") - hospital[i].get("x")) ** 2 + (
                        ugv_json_format[uxv_name_].get("uxv_y") - hospital[i].get("y")) ** 2
                uzaklik = math.sqrt(uzaklik)
                if uzaklik <= minhospital:
                    minhospital = uzaklik
                    MinimumIndexHospital = i

            library = hospital
            keyNokta = MinimumIndexHospital

        if (patient[patientNo]["requirement"] == REQUIREMENT_FOOD):
            minheadquarter = math.sqrt(
                (ugv_json_format[uxv_name_].get("uxv_x") - headquarter["headquarter_1"].get("x")) ** 2 + (
                        ugv_json_format[uxv_name_].get("uxv_y") - headquarter["headquarter_1"].get("y")) ** 2)
            for i in headquarter:
                uzaklik = (ugv_json_format[uxv_name_].get("uxv_x") - headquarter[i].get("x")) ** 2 + (
                        ugv_json_format[uxv_name_].get("uxv_y") - headquarter[i].get("y")) ** 2
                uzaklik = math.sqrt(uzaklik)
                print(uzaklik)
                print(minheadquarter)
                if uzaklik <= minheadquarter:
                    minheadquarter = uzaklik
                    MinimumIndexHeadquarter = i

            library = headquarter
            keyNokta = MinimumIndexHeadquarter

        x_point = library[keyNokta]["x"]
        y_point = library[keyNokta]["y"]

        uzaklik2 = (ugv_json_format[uxv_name_].get("uxv_x") - library[keyNokta]["x"]) ** 2 + (
                ugv_json_format[uxv_name_].get("uxv_y") - library[keyNokta]["y"]) ** 2
        uzaklik2 = math.sqrt(uzaklik2)

        print(uzaklik2)

        if (uzaklik2 <= 8):
            print("Uzaklik 8in altina dustu!!")
            noktayaUlasildi = True


    print(x_point)
    print(y_point)


def teslimatAl(patientNo):
    global loadKontrol
    global TekSeferCalisacakGidilecekKoordKontrol
    cargo_type = ""
    amount_number = 1
    source_poi = ""

    uzaklik = 0

    if(patient[patientNo]["requirement"] == REQUIREMENT_HOSPITAL):
        cargo_type = CARGO_TYPE_PATIENT
        source_poi = patientNo


    if (patient[patientNo]["requirement"] == REQUIREMENT_FOOD):
        cargo_type = REQUIREMENT_FOOD
        source_poi = MinimumIndexHeadquarter

    if (patient[patientNo]["requirement"] == REQUIREMENT_MEDICINE):
        cargo_type = REQUIREMENT_MEDICINE
        source_poi = MinimumIndexHospital

    rospy.wait_for_service('/karmasim_node/vehicle_load')
    req = rospy.ServiceProxy('/karmasim_node/vehicle_load', VehicleLoad)
    res = req(uxv_name_, source_poi, cargo_type, amount_number)
    print('load result: %s\t message: %s ' % (res.success, res.message))
    print(res.success)

    counter = 0

    if (res.success == True and counter == 0):
        loadKontrol = True
        TekSeferCalisacakGidilecekKoordKontrol = False
        counter = 1

def hastaneyeGit(patientNo):
    global x_patient
    global y_patient
    global hastayaUlasildi
    global MinimumIndexHospital

    hospital = functions.createHospital(points_of_interest_konumlari)

    minhospital = (ugv_json_format[uxv_name_].get("uxv_x") - hospital["hospital_1"].get("x")) ** 2 + (
            ugv_json_format[uxv_name_].get("uxv_y") - hospital["hospital_1"].get("y")) ** 2
    minhospital = math.sqrt(minhospital)


    if len(hospital)>0:
        for i in hospital:
            uzaklik = (ugv_json_format[uxv_name_].get("uxv_x") - hospital[i].get("x")) ** 2 + (
                    ugv_json_format[uxv_name_].get("uxv_y") - hospital[i].get("y")) ** 2
            uzaklik = math.sqrt(uzaklik)
            if (hospital[i].get("current_quotas") != 0):
                if uzaklik <= minhospital:
                    minhospital = uzaklik
                    MinimumIndexHospital = i
            else:
                print("Kota dolu")
                id = int(''.join(x for x in i if x.isdigit()))
                temp = id + 1
                if (temp > len(hospital)):
                    temp = 1
                MinimumIndexHospital = "hospital_" + str(temp)


        x_patient = hospital[MinimumIndexHospital]["x"]
        y_patient = hospital[MinimumIndexHospital]["y"]

        print("Burda1")
        uzaklik = (ugv_json_format[uxv_name_].get("uxv_x") - x_patient) ** 2 + (
                ugv_json_format[uxv_name_].get("uxv_y") - y_patient) ** 2

        uzaklik = math.sqrt(uzaklik)
        if (uzaklik <= 8):
            print("uzaklik 8den kucuk")
            hastayaUlasildi = True

def teslimataGit(patientNo):
    global x_patient
    global y_patient
    global hastayaUlasildi

    x_patient = patient[patientNo]["x"]
    y_patient = patient[patientNo]["y"]

    uzaklik = (ugv_json_format[uxv_name_].get("uxv_x") - x_patient) ** 2 + (
            ugv_json_format[uxv_name_].get("uxv_y") - y_patient) ** 2

    uzaklik = math.sqrt(uzaklik)
    if (uzaklik <= 8):
        print("uzaklik 8den kucuk")
        hastayaUlasildi = True


def teslimatBirak(patientNo):
    global unloadKontrol
    global MinimumIndexHospital
    global hastaTasinacak
    global hastayaUlasildi
    global loadKontrol
    global noktayaUlasildi
    global HastaSecildi
    global TekSeferCalisacakGidilecekKoordKontrol
    target_poi = ""
    amount_number = 1
    cargo_type = ""

    hospital = functions.createHospital(points_of_interest_konumlari)

    if (patient[patientNo]["requirement"] == REQUIREMENT_HOSPITAL):
        cargo_type = 5
        target_poi = MinimumIndexHospital


    if (patient[patientNo]["requirement"] == REQUIREMENT_FOOD):
        cargo_type = REQUIREMENT_FOOD
        target_poi = patientNo
    if (patient[patientNo]["requirement"] == REQUIREMENT_MEDICINE):
        cargo_type = REQUIREMENT_MEDICINE
        target_poi = patientNo

    rospy.wait_for_service('/karmasim_node/vehicle_unload')
    req = rospy.ServiceProxy('/karmasim_node/vehicle_unload', VehicleUnload)
    res = req(uxv_name_, target_poi, cargo_type, amount_number)
    print('unload result: %s\t message: %s ' % (res.success, res.message))

    if (res.success == True):
        unloadKontrol = False
        hastaTasinacak = False
        hastayaUlasildi = False
        loadKontrol = False
        noktayaUlasildi=False
        HastaSecildi = False
        TekSeferCalisacakGidilecekKoordKontrol = False
        patient.pop(patientNo, None)


if __name__ == "__main__":
    settings = termios.tcgetattr(sys.stdin)

    rospy.init_node('karmasim_ugv_teleop')
    pub = rospy.Publisher('ugv_cmd', CarControls, queue_size=10)

    status = 0
    target_throttle = 0.0
    target_steering = 0.0

    car_cmd = CarControls()
    car_cmd.handbrake = False
    car_cmd.manual = False
    car_cmd.gear_immediate = True

    uxv_name = rospy.get_param('~uxv_name', 'ugv_1')
    rospy.Subscriber('/karmasim_node/uxv_states', UxvStates, Uxv_states)
    rospy.Subscriber('/karmasim_node/' + uxv_name + '/odom_local_ned', Odometry, getOdometry)
    rospy.Subscriber('/karmasim_node/points_of_interest', PointsOfInterest, points_of_interest)

    rospy.Subscriber('/karmasim_node/' + uxv_name + '/distance/dist_front_right', Range, sensor_distance_front_right)
    rospy.Subscriber('/karmasim_node/' + uxv_name + '/distance/dist_front_left', Range, sensor_distance_front_left)
    rospy.Subscriber('/karmasim_node/' + uxv_name + '/distance/dist_front_center', Range, sensor_distance_front_center)
    rospy.Subscriber('/karmasim_node/' + uxv_name + '/distance/dist_back_center', Range, sensor_distance_back_center)

    HastayaGidiyorum = rospy.Publisher('Hastam', Int16, queue_size=10)
    rospy.Subscriber("Hastam", Int16, callback)

    contest_parameters = rospy.get_param('/scenario')
    world_boundaries = contest_parameters["world_boundaries"]
    asset_count = contest_parameters["asset_count"]
    print('World Boundaries')
    print(world_boundaries)

    print(ugv_json_format)
    KomsuKavsaklar = functions.KomsuKavsakGetir()
    KavsakKoordinat = functions.KavsakNoktaGetir()
    LimitleriGetir()
    YuvayaDon=False

    try:
        rospy.wait_for_service('/karmasim_node/vehicle_start')
        request = rospy.ServiceProxy('/karmasim_node/vehicle_start', VehicleStart)
        result = request(uxv_name)
        uxv_name_ = rospy.get_param('~uxv_name', "algan")

        BaslangicKonum = False
        if (len(ugv_json_format) != 0):
            baslangic_x, baslangic_y, baslangic_z = functions.ugv_BaslangicKonunum(ugv_json_format, uxv_name_)
            BaslangicKonum = True
        while 1:
            key = getKey()
            if (len(ugv_json_format) != 0):
                if (BaslangicKonum == False):
                    baslangic_x, baslangic_y, baslangic_z = functions.ugv_BaslangicKonunum(ugv_json_format, uxv_name_)
                    BaslangicKonum = True
                if (len(patient) != 0):
                    if (len(charge_station) != 0):
                        if (len(hospital) != 0):
                            if (len(headquarter) != 0):
                                if flag_gidilecek == True:
                                    print("kalan sarj :", ugv_json_format[uxv_name_]["fuel_current"])
                                    if (SarjaGit == False and len(charge_station) != 0):
                                        # ---------------------------------------- Zeynep ---------------------------------------------
                                        if (HastaSecildi == False):
                                            patientNo = HastaBul()
                                            #patientNo = "patient_7"
                                        if (patientNo != ""):
                                            HastayaGidiyorum.publish(patient[patientNo]["id"])
                                            print(patientNo)
                                            if (loadKontrol == False):
                                                print(patientNo)
                                                print("Burada 1")
                                                yakinNoktayiBul(patientNo)
                                                print("Burda 2")
                                                if (noktayaUlasildi == False):
                                                    GidilecekKoordinat(x_point, y_point)
                                                    print("goreve ulasilmadi")
                                                if (noktayaUlasildi == True):
                                                    if (gorevKontrol == False):
                                                        teslimatAl(patientNo)
                                                    if (gorevKontrol == True):
                                                        print("Gorevegidilemiyor")
                                                    print("GoreveGidiliyor")
                                            else:
                                                if (unloadKontrol == False):
                                                    if (hastaTasinacak == True):
                                                        print("HAstaneye")
                                                        hastaneyeGit(patientNo)
                                                    else:
                                                        teslimataGit(patientNo)
                                                    if (hastayaUlasildi == False):
                                                        print("Burdaulasildifalse")
                                                        GidilecekKoordinat(x_patient, y_patient)
                                                    else:
                                                        teslimatBirak(patientNo)
                                                print("GoreveGidiliyor")
                                                if (unloadKontrol == False and hastayaUlasildi == True):
                                                    print("Bitti")
                                                    #hastaneyeGit(patientNo)
                                                    #GidilecekKoordinat(x_patient, y_patient)

                                        else:
                                            print("Hastalar Bitti Yuvaya Donuyoruz")
                                            if (YuvayaDon == False):
                                                TekSeferCalisacakGidilecekKoordKontrol = False
                                                YuvayaDon = True
                                            GidilecekKoordinat(baslangic_x, baslangic_y)

                                        SarjYetiyorMu()
                                        print("GoreveGidiliyor")
                                    elif (SarjaGit == True):
                                        GidilecekKoordinat(charge_station[MinimumIndexChargeStation].get('x'),charge_station[MinimumIndexChargeStation].get('y'))
                                        SarjKontrol()
                                        print("SarjaGidiliyor")

                                obstacle_aviodance(xHizi, angleHizi)
                                counter = 0
                            else:
                                headquarter = functions.createHeadquarter(points_of_interest_konumlari)
                        else:
                            hospital = functions.createHospital(points_of_interest_konumlari)
                    else:
                        charge_station = functions.createChargeStation(points_of_interest_konumlari)
                else:
                    patient = functions.createPatient(points_of_interest_konumlari)
            if (key == '\x03'):
                break
    except:
        print(e)
    finally:
        car_cmd = CarControls()
        car_cmd.handbrake = False
        car_cmd.manual = False
        car_cmd.gear_immediate = True
        car_cmd.throttle = 0
        car_cmd.steering = 0
        car_cmd.brake = 0
        pub.publish(car_cmd)
        request = rospy.ServiceProxy('/karmasim_node/vehicle_stop', VehicleStop)
        result = request(uxv_name)

    termios.tcsetattr(sys.stdin, termios.TCSADRAIN, settings)
